/*
 * File: BCU.c
 *
 * Code generated for Simulink model 'BCU'.
 *
 * Model version                  : 1.33
 * Simulink Coder version         : 9.4 (R2020b) 29-Jul-2020
 * C/C++ source code generated on : Thu Sep  9 18:19:09 2021
 *
 * Target selection: ert.tlc
 * Embedded hardware selection: Intel->x86-64 (Windows64)
 * Code generation objectives: Unspecified
 * Validation result: Not run
 */

#include "BCU.h"

static StaticTask_t         gProcess_Bcu_Task_t;
static UINT8                gProcess_Bcu_TaskStack[PROC_BCU_TASK_STACK_SIZE];
static osThreadId_t         BcuTaskId = NULL;
static process_Bcu 		    gProcess_Bcu_Task;
#define PROC_BCU_STATE_SWITCH(a)  (gProcess_Bcu_Task = a)
/* Real-time model */
static RT_MODEL_BCU_T BCU_M_;
RT_MODEL_BCU_T *const BCU_M = &BCU_M_;

//======================================================
void BCU(void)
{     
      uint16_T i;
      static uint16_T sleep_time;
	  UINT32 locateTimeCounter = 0;
	  osDelay(3000);
	  PROC_BCU_STATE_SWITCH(PROCESS_STATE_INIT);
	  
	  while (TRUE)
	  {
		switch(gProcess_Bcu_Task)
		{
		  case PROCESS_STATE_INIT:	
		  {
		    BCU_Init();  
			memcpy(blcv_Q_totalCpEi,BcuDataInfo.blcv_Q_totalCpE, sizeof(blcv_Q_totalCpEi));		 
			memcpy(blcv_Q_reqCpEi,BcuDataInfo.blcv_Q_reqCpE, sizeof(blcv_Q_reqCpEi));	 
			socd_pct_bcuSocEi = BcuDataInfo.socd_pct_bcuSocE;			
			socd_pct_battSocEi = BcuDataInfo.socd_pct_battSocE; 		
			sohd_tm_chrgStartStatEi = BcuDataInfo.sohd_tm_chrgStartStatE;	  
			sohd_flg_chrgEndEi = BcuDataInfo.sohd_flg_chrgEndE; 		   
			memcpy(sohv_V_chrgStartStatEi,BcuDataInfo.sohv_V_chrgStartStatE, sizeof(sohv_V_chrgStartStatEi));
			sohd_Q_chrgEi = BcuDataInfo.sohd_Q_chrgE;				  
			memcpy(sohv_Q_packCapArrEi,BcuDataInfo.sohv_Q_packCapArrE, sizeof(sohv_Q_packCapArrEi));
			memcpy(sohv_Q_cellCapArrEi,BcuDataInfo.sohv_Q_cellCapArrE, sizeof(sohv_Q_cellCapArrEi));
			PROC_BCU_STATE_SWITCH(PROCESS_STATE_WORK);
			break;
		  }
		  //------------------------------------------------------------------------------------	  
		  case PROCESS_STATE_WORK:
		  { 
		    sleep_time=0;
			while (TRUE)
			{
			  	//osDelay(100);
			  	if(locateTimeCounter != TimeCounter)
			  	{
					  locateTimeCounter = TimeCounter;
					  if(BattWorkStateDelay==0&&battI==10000)
					  {
					    sleep_time++;
					    if(sleep_time>100)
					  	 {
					  	 sleep_time=101;
						  PROC_BCU_STATE_SWITCH(PROCESS_STATE_SLEEP);
						  break;
					     }
					  }
					  else
					  {
					  	sleep_time = 0;
					  }
					//  printf("sleep_time:%d,BattWorkStateDelay:%d,battI:%d\n",sleep_time,BattWorkStateDelay,battI);
					  
					  //=============================================================================
					  ihd_I_curr = (int16_T)(-(battI - 10000));
					  memcpy(ihv_V_cellU,battCellU,sizeof(battCellU));
					  for(i=0;i<cmnc_num_modTNum;i++)
					  	{
						  ihv_T_modT[i]= (int16_T) (battCellTemp[i]-40);

					  	}

					  ihd_st_workStat  = BattWorkStateDelay;
					  ihd_L_urtRecv=!UartErrorFlag;
					  ihd_flg_chrgMosClosFlt= ((battWarningState >> 19) & 0x01) == 1;
					  ihd_flg_dischrgMosClosFlt=((battWarningState >> 18) & 0x01) == 1;
		              ihd_flg_currFlt =((battWarningState >> 18) & 0x01) == 1;

					  //=============================================================================
					  SFM();
					  SPM();

					 //==============================shi shi cun chu=======
					  if(socd_flg_EEsave==1)
					  {
						 BCUEEDataSave();
					  }
			  	}
				osDelay(5);
			}
			break;
		  }
		  //----------------------------------------------------------------------------------------------------
		  case PROCESS_STATE_SLEEP:
		  { 
			BCUEEDataSave();
			//
			ihd_tm_parkTime=0;
			while (TRUE)
			{
			  osDelay(1000);
			  ihd_tm_parkTime++;
			  //printf("ihd_tm_parkTime:%d\n",ihd_tm_parkTime);
			  if(BattWorkStateDelay==0&&battI==10000)
			  {    
			    memcpy(appv_V_cellU,battCellU,sizeof(appv_V_cellU));
			  }

			  if(BattWorkStateDelay!=0||ihd_tm_parkTime>cmnc_tm_parkTime+10||battI!=10000)
			  {
				PROC_BCU_STATE_SWITCH(PROCESS_STATE_INIT);
				break;
			  }
			}
			break;
		  }
		  default:
		  {
			PROC_BCU_STATE_SWITCH(PROCESS_STATE_INIT);
			break;
		  }
		}
	  }
}

/* Model initialize function */
void BCU_Init(void)
{

  SFM_initialize(rtmGetErrorStatusPointer(BCU_M));
  SFM_Init();
  SPM_Init();
}


//================================================================================
void AppTaskBcuInit(void *arg)
{
		osThreadAttr_t task_attr;
		memset(&task_attr,0,sizeof(task_attr));
		memset(gProcess_Bcu_TaskStack, 0xA5, PROC_BCU_TASK_STACK_SIZE);
		task_attr.name = "Bcu_Task";
		task_attr.stack_mem = gProcess_Bcu_TaskStack;
		task_attr.stack_size = PROC_BCU_TASK_STACK_SIZE;
		task_attr.priority = osPriorityBelowNormal7;
		task_attr.cb_mem = &gProcess_Bcu_Task_t;
		task_attr.cb_size = sizeof(StaticTask_t);
		BcuTaskId = osThreadNew(BCU, NULL, &task_attr);
}
//=========================================================================================
void BCUEEDataSave(void)
{
	  memcpy(BcuDataInfo.blcv_Q_totalCpE,blcv_Q_totalCpEo, sizeof(blcv_Q_totalCpEo));	   
	  memcpy(BcuDataInfo.blcv_Q_reqCpE,blcv_Q_reqCpEo, sizeof(blcv_Q_reqCpEo));	
	  BcuDataInfo.socd_pct_bcuSocE =  socd_pct_bcuSocEo;  
	  BcuDataInfo.socd_pct_battSocE = socd_pct_battSocEo;
	  BcuDataInfo.sohd_tm_chrgStartStatE = sohd_tm_chrgStartStatEo;
	  BcuDataInfo.sohd_flg_chrgEndE = sohd_flg_chrgEndEo;	  
	  memcpy(BcuDataInfo.sohv_V_chrgStartStatE,sohv_V_chrgStartStatEo, sizeof(sohv_V_chrgStartStatEo));
	  BcuDataInfo.sohd_Q_chrgE = sohd_Q_chrgEo;		   
	  memcpy(BcuDataInfo.sohv_Q_packCapArrE,sohv_Q_packCapArrEo, sizeof(sohv_Q_packCapArrEo));
	  memcpy(BcuDataInfo.sohv_Q_cellCapArrE,sohv_Q_cellCapArrEo, sizeof(sohv_Q_cellCapArrEo));
	  BcuDataInfo.appDataModify = TRUE;

 }
 
